<template>
<el-main>
<!--陈述（申辩）笔录-->
  <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
    <el-row>
      <el-col :span="12">
        <el-form-item label="开始时间" :label-width="formLabelWidth">
          <el-date-picker
            v-model="form.explainStartTime"
            type="datetime"
            :value-format="`yyyy-MM-dd HH:mm:ss`"
            placeholder="选择日期"
            style="width: 100%"
          >
          </el-date-picker>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="结束时间" :label-width="formLabelWidth">
          <el-date-picker
            v-model="form.explainEndTime"
            type="datetime"
            :value-format="`yyyy-MM-dd HH:mm:ss`"
            placeholder="选择日期"
            style="width: 100%"
          >
          </el-date-picker>
        </el-form-item>
      </el-col>
    </el-row>
    <el-form-item label="地点" :label-width="formLabelWidth">
      <el-input v-model="form.explainAddr"></el-input>
    </el-form-item>
    <el-row>
      <el-col :span="12">
        <el-form-item label="申辩人" :label-width="formLabelWidth">
          <el-input v-model="form.explainPersonName"></el-input>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="身份证号" :label-width="formLabelWidth">
          <el-input v-model="form.explainPersonIdCard"></el-input>
        </el-form-item>
      </el-col>
    </el-row>
    <el-form-item label="工作单位" :label-width="formLabelWidth">
      <el-input v-model="form.explainPersonCompany"></el-input>
    </el-form-item>
    <el-form-item label="住址" :label-width="formLabelWidth">
      <el-input v-model="form.explainPersonAddr"></el-input>
    </el-form-item>
    <el-row>
      <el-col :span="12">
        <el-form-item label="电话" :label-width="formLabelWidth">
          <el-input v-model="form.explainPersonPhone"></el-input>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="邮编" :label-width="formLabelWidth">
          <el-input v-model="form.explainPersonPostcode"></el-input>
        </el-form-item>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <el-form-item label="与本案关系" :label-width="formLabelWidth">
          <el-input v-model="form.explainPersonRelation"></el-input>
        </el-form-item>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <el-form-item label="记录人" :label-width="formLabelWidth">
          <el-input v-model="form.recordPersonName"></el-input>
        </el-form-item>
      </el-col>
      <el-col :span="12">
        <el-form-item label="工作单位" :label-width="formLabelWidth">
          <el-input v-model="form.recordPersonCompany"></el-input>
        </el-form-item>
      </el-col>
    </el-row>
    <el-form-item label="申辩目的" :label-width="formLabelWidth">
      <el-input v-model="form.explainGoal"></el-input>
    </el-form-item>
    <el-form-item label="申辩事实及理由" :label-width="formLabelWidth">
      <el-input type="textarea" v-model="form.explainContent"></el-input>
    </el-form-item>
    <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
  </el-form>
  <div style="text-align: center;">
    <el-button v-show="form.registerState != '1'" plain @click="dataFormSubmit('0')">保存</el-button>
    <el-button v-show="form.registerState != '1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
    <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
    <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
  </div>
</el-main>
</template>

<script>
import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/TranscriptOfStatement";
import moment from "moment";

export default {
  name: "TranscriptOfStatement",
  props: ['isShowYulan', 'id', 'isFinish', 'processId', 'title'],
  components: {
    WordView
  },
  data() {
    return {
      showView: false,
      form: {
        explainStartTime:"",
        explainEndTime:"",
        explainAddr:"",
        explainPersonName:"",
        explainPersonIdCard:"",
        explainPersonCompany:"",
        explainPersonAddr:"",
        explainPersonPhone:"",
        explainPersonPostcode:"",
        explainPersonRelation:"",
        recordPersonName:"",
        recordPersonCompany:"",
        explainGoal:"",
        explainContent:"",
      },
      formLabelWidth: "140px",
    };
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      this.getBiLu()
    },
    getBiLu() {
      getObj(this.id).then(res => {
        // 转换null为""
        let v = res.data.data
        for (let attr in v) {
          if (v[attr] == null) {
            v[attr] = "";
          }
        }
        this.form = v;
      })
    },
    dataFormSubmit(type) {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/TranscriptOfStatement.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/TranscriptOfStatement.docx", this.title+'.docx');
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.explainStartTime != '' && data.explainStartTime != null) {
        data.explainStartTime = moment(data.explainStartTime).format('YYYY年MM月DD日HH时mm分');
      } else {
        data.explainStartTime = '  年  月  日  时  分'
      }

      if (data.explainEndTime != '' && data.explainEndTime != null) {
        data.explainEndTime = moment(data.explainEndTime).format('HH时mm分');
      } else {
        data.explainEndTime = '  时  分'
      }

      return data;
    }
  }
}
</script>

<style scoped>

</style>
